# more_sjis_analyse.pl -- Shift_JISから文字種をさらに細かく分別

use utf8;

$in = shift;

binmode STDOUT, ":encoding(cp932)";

open IN, "<:encoding(cp932)", $in;

while (<IN>) {
    foreach $c (/\p{InCJKUnifiedIdeographs}+/g) {
        print "$.行-漢字: $c\n";
    }
    foreach $c (/\p{Hiragana}+/g) {
        print "$.行-かな: $c\n";
    }
    foreach $c (/\p{InKatakana}+/g) {
        print "$.行-カナ: $c\n";
    }
    foreach $c (/\p{HankakuKana}+/g) {
        print "$.行-ﾊﾝｶﾅ: $c\n";
    }
    foreach $c (/\p{HankakuAbcd}+/g) {
        print "$.行- abcd: $c\n";
    }
    foreach $c (/\p{Hankaku1234}+/g) {
        print "$.行- 1234: $c\n";
    }
}

sub HankakuKana {
    return <<END;
FF66 FF9F # 半角カナ
END
}

sub HankakuAbcd {
    return <<END;
0041 005A # 半角英大文字
0061 007A # 半角小大文字
END
}

sub Hankaku1234 {
    return <<END;
0030 0039 # 半角数字
END
}

