# sjis_analyse_3.pl -- Shift_JISから文字種を分別（Unicodeプロパティを使用）

use utf8;

$in = shift;

binmode STDOUT, ":encoding(cp932)";

open IN, "<:encoding(cp932)", $in;

while (<IN>) {
    print "$.行-漢字: $_" if /\p{InCJKUnifiedIdeographs}/;
    print "$.行-かな: $_" if /\p{Hiragana}/;
    print "$.行-カナ: $_" if /\p{InKatakana}/;
    print "$.行-ﾊﾝｶﾅ: $_" if /\p{HankakuKana}/;
    print "$.行-abcd: $_" if /\p{HankakuAbcd}/;
    print "$.行-1234: $_" if /\p{Hankaku1234}/;
}

close IN;

sub HankakuKana {
    return <<END;
FF66 FF9F # 半角カナ
END
}

sub HankakuAbcd {
    return <<END;
0041 005A # 半角英大文字
0061 007A # 半角小大文字
END
}

sub Hankaku1234 {
    return <<END;
0030 0039 # 半角数字
END
}

